# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


%define with_java5 %{?_with_java5:1}%{!?_with_java5:%{?_without_java5:0}%{!?_without_java5:%{?_java5:%{_java5}}%{!?_java5:0}}}
%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?with_java5:0}}}

%define section         free

Summary:        A Multipurpose Infrastructure for Network Applications
Name:           mina
Version:        1.0.0
Release:        3jpp
Epoch:		0
Group:          System/Networking
License:        Apache 2.0 License
URL:            http://directory.apache.org/subprojects/mina/
Source0:        %{name}-%{version}.tar.gz
# svn export http://svn.apache.org/repos/asf/directory/releases/mina/1.0.0 mina-1.0.0

Source1:        directory-pom-1.0.4.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml

Patch0:		mina-pom_xml.patch
Patch1:		mina-site_xml.patch

Vendor:         JPackage Project
Distribution:   JPackage
BuildRequires:  jpackage-utils >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.4
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire

BuildRequires:  saxon
BuildRequires:  saxon-scripts
Requires:	java-devel >= 0:1.4.2
%if ! %{with_java5}
Requires:	java-devel < 0:1.5
%endif
BuildRequires:	junit
BuildRequires:	easymock
BuildRequires:	slf4j
BuildRequires:	backport-util-concurrent
BuildRequires:	tl-netty2
BuildRequires:	jzlib

Requires:	java >= 0:1.4.2
%if ! %{with_java5}
Requires:	java < 0:1.5
%endif
Requires:	backport-util-concurrent
Requires:	slf4j
Obsoletes:	mina-jdk14 < 0:1.0.0
Provides:	mina-jdk14
%if %{gcj_support}
BuildRequires:          gnu-crypto
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
MINA (Multipurpose Infrastructure for Network Applications) is a
network application framework which helps users develop high
performance and high scalability network applications easily.

%if ! %{with_java5}
THIS PARTIAL RELEASE DOES NOT PROVIDE SSL SUPPORT.
%endif

%package filter-codec-netty
Group:          System/Networking
Summary:        Netty2 filter for %{name}
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	tl-netty2
%if %{gcj_support}
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description filter-codec-netty
%{summary}.

%package filter-compression
Group:          System/Networking
Summary:        JZlib compression filter for %{name}
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	jzlib
%if %{gcj_support}
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description filter-compression
%{summary}.

%if %{with_java5}
%package filter-ssl
Group:          System/Networking
Summary:        SSL filter for %{name}
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	slf4j

%description filter-ssl
%{summary}.

%package integration-jmx
Group:          System/Networking
Summary:        JMX integration for %{name}
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description integration-jmx
%{summary}.

%package integration-spring
Group:          System/Networking
Summary:        Spring integration for %{name}
Requires:	%{name}-filter-ssl = %{epoch}:%{version}-%{release}
Requires:	slf4j
Requires:	spring-beans
Requires:	spring-core

%description integration-spring
%{summary}.

%package java5
Group:          System/Networking
Summary:        Java5 extensions for %{name}
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	slf4j

%description java5
%{summary}.

%package demo
Group:          System/Networking
Summary:        Examples for %{name}
Requires:	%{name}-filter-ssl = %{epoch}:%{version}-%{release}
Requires:	%{name}-integration-spring = %{epoch}:%{version}-%{release}
Requires:	nlog4j
Requires:	spring-context
Requires:	spring-support

%description demo
%{summary}.

%endif

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%package manual
Group:          Development/Documentation
Summary:        Documents for %{name}

%description manual
%{summary}.

%prep
%setup -q -n %{name}-%{version}

%if ! %{with_java5}
%patch0 -b .sav
%endif
%patch1 -b .sav

%build
cp %{SOURCE3} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

for p in $(find . -name "*.pom"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done

for p in $(find . -name "*pom.xml"); do
    pushd $(dirname $p)
    bp=`basename $p`
    cp $bp $bp.orig
    /usr/bin/saxon -o $bp $bp.orig /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
    popd
done
%if ! %{with_java5}
/usr/bin/saxon -o pom-javadoc.xml pom.xml.sav /usr/share/java-utils/xml/maven2jpp-mapdeps.xsl map=%{SOURCE2}
%endif

mkdir -p m2_repo/repository/JPP/maven2/default_poms
cp %{SOURCE1} m2_repo/repository/JPP/maven2/default_poms/org.apache.directory-build.pom
cp pom.xml m2_repo/repository/JPP/maven2/default_poms/org.apache.mina-build.pom

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%if ! %{with_java5}
export JAVA_HOME=%{_jvmdir}/java-1.4.2
%else
export JAVA_HOME=%{_jvmdir}/java-1.5.0
%endif
MVN=/usr/bin/mvn
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.mode=true -Dmaven.test.failure.ignore=true -Djava.awt.headless=true"
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} install
%if ! %{with_java5}
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} -f pom-javadoc.xml -N install
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} site
%else
${MVN} -s ${M2SETTINGS} ${MAVEN_OPTS} -N site
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/mina

install -m 644 core/target/%{name}-core-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 filter-codec-netty/target/%{name}-filter-codec-netty-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/filter-codec-netty-%{version}.jar
install -m 644 filter-compression/target/%{name}-filter-compression-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/filter-compression-%{version}.jar
%if %{with_java5}
install -m 644 example/target/%{name}-example-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/example-%{version}.jar
install -m 644 filter-ssl/target/%{name}-filter-ssl-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/filter-ssl-%{version}.jar
install -m 644 integration-jmx/target/%{name}-integration-jmx-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-jmx-%{version}.jar
install -m 644 integration-spring/target/%{name}-integration-spring-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-spring-%{version}.jar
install -m 644 java5/target/%{name}-java5-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/java5-%{version}.jar
%endif

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

pushd $RPM_BUILD_ROOT%{_javadir}
   ln -fs %{name}/core-%{version}.jar %{name}-jdk14-%{version}.jar
   ln -fs %{name}/core.jar %{name}-jdk14.jar
popd

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/site/apidocs*

# manual
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/
cp -p core/LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post filter-codec-netty
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun filter-codec-netty
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post filter-compression
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun filter-compression
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}/core*.jar
%{_javadir}/%{name}-jdk14*.jar
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/core-%{version}.jar.*
%endif

%files filter-codec-netty
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/filter-codec-netty*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/filter-codec-netty-%{version}.jar.*
%endif

%files filter-compression
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/filter-compression*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/filter-compression-%{version}.jar.*
%endif

%if %{with_java5}

%files filter-ssl
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/filter-ssl*.jar

%files integration-jmx
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/integration-jmx*.jar

%files integration-spring
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/integration-spring*.jar

%files java5
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/java5*.jar

%files demo
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/example*.jar


%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%changelog
* Thu Mar 15 2007 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-3jpp
- Add maven2-plugin-* BRs

* Wed Oct 25 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-2jpp
- Fix macro

* Wed Oct 25 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-1jpp
- Update to 1.0.0 for apacheds
- Add --with java5 to build full release

* Sun Feb 12 2006 Ralph Apel <r.apel at r-apel.de> 0:0.8.0-1jpp
- First JPackage release.
